# Changelog

All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),
and this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).

## 5.2.1-alpha6
This release updates the supported node to v22.11, introduces JS Linting, and new UI menu animation options that allow users to select sliding out from left/right or top down. Updated form styles and icons resolve several bug issues. Also in this release the project README file has been split it into two files, one that supports generating a theme and the other for leveraging prototype development features like build tools.

### Changelog

**Issues**: 12 issues resolved.

Changes since [5.2.1-alpha5](https://www.drupal.org/project/prototype/releases/5.2.1-alpha5):

#### Bug

* [#3501297](https://www.drupal.org/i/3501297) by pixelwhip: Some base stylesheets are not being loaded
* [#3499806](https://www.drupal.org/i/3499806): Node attributes on full view mode are bleeding into page-title
* [#3494933](https://www.drupal.org/i/3494933) by jldust, alok_singh: In Footer, footer title and footer menu should be aligned.
* [#3495195](https://www.drupal.org/i/3495195): On User register page, Field spacing issue, and in content setting, content are not visible.
* [#3494955](https://www.drupal.org/i/3494955) by jldust, alok_singh: In Advance search, Types and Language checkbox's needs to be fixed and Advance search button needs some space

#### Feature

* [#3469553](https://www.drupal.org/i/3469553) by jldust: Revise Component: Button
* [#3500988](https://www.drupal.org/i/3500988) by philip_stier, pixelwhip: JavaScript Linting with ESLint
* [#3460852](https://www.drupal.org/i/3460852) by b-ry: Optional Menu Animations

#### Task

* [#3493422](https://www.drupal.org/i/3493422) by jldust, pixelwhip: Remove the _animation.scss partial
* [#3443350](https://www.drupal.org/i/3443350) by pixelwhip, jldust: Update core project readme
* [#3504141](https://www.drupal.org/i/3504141): Remove Icon prefix from svg files
* [#3493443](https://www.drupal.org/i/3493443) by jldust: Update Node and packages

## 5.2.1-alpha5
As we move towards standardization this release removes the prefix on component variables throughout all components within Prototype. When pulling updated components from this version ensure you validate updated component variable names.

### Changelog

**Issues**: 12 issues resolved.

Changes since [5.2.1-alpha4](https://www.drupal.org/project/prototype/releases/5.2.1-alpha4):

#### Task

* [#3488784](https://www.drupal.org/i/3488784) by rohan_singh, deepali sardana, jldust, jaydeep_patel: Component: Update Page Title Props
* [#3488776](https://www.drupal.org/i/3488776) by pixelwhip, jldust: Component: Update CTA  Props
* [#3488792](https://www.drupal.org/i/3488792) by jldust: Component: Update Video Props
* [#3488791](https://www.drupal.org/i/3488791) by jldust, ananya.k: Component: Update Teaser Props
* [#3488787](https://www.drupal.org/i/3488787) by jldust, ananya.k: Component: Update Slideshow Props
* [#3488786](https://www.drupal.org/i/3488786): Component: Update Pullquote Props
* [#3488779](https://www.drupal.org/i/3488779) by jldust, niharika.s: Component: Update Link Props
* [#3488774](https://www.drupal.org/i/3488774) by b-ry, ananya.k, jldust: Component: Update Breadcrumb Props
* [#3488775](https://www.drupal.org/i/3488775) by jldust, niharika.s: Component: Update Button Props
* [#3488777](https://www.drupal.org/i/3488777) by b-ry, jldust, ananya.k: Component: Update Figure Props
* [#3488790](https://www.drupal.org/i/3488790) by jldust, ananya.k: Component: Update Tabs Content Props
* [#3488782](https://www.drupal.org/i/3488782) by jldust, niharika.s: Component: Update Menu Props

## 5.2.1-alpha4
With this release the previous accordion_group component has been removed, and the accordion component has been updated with a new structure and improved styles. Enhancements have been made to the pager component, including a more comprehensive README, an updated component.yml file, and a simplified template. Theme view suggestions, which were removed in an earlier version, have now been reintroduced to improve flexibility in theme customization. The menu component has been upgraded to support more complex, nested menu structures, including menus that function without button controls.

### Changelog

**Issues**: 4 issues resolved.

Changes since [5.2.1-alpha3](https://www.drupal.org/project/prototype/releases/5.2.1-alpha3):

#### Feature

* [#3483019](https://www.drupal.org/i/3483019) by jldust, droath: Add views theme suggestions

#### Support

* [#3480037](https://www.drupal.org/i/3480037) by jldust, pixelwhip, philip_stier: Nested Menus with <nolink>

#### Task

* [#3481201](https://www.drupal.org/i/3481201) by philip_stier, jldust: Updated Pager Component
* [#3480006](https://www.drupal.org/i/3480006) by philip_stier: Updated Accordion Component

## 5.2.1-alpha3
This release includes a major overhaul of the folder structure for components and libraries as well as an updated WYSIWYG file setup. In addition the menu component has been simplified with its library files and split for better readability, this also includes new README files explaining how to best leverage the menu component. Fixes an issue with the type-scale not placing breakpoint styles in the correct order.

### Changelog

**Issues**: 5 issues resolved.

Changes since [5.2.1-alpha2](https://www.drupal.org/project/prototype/releases/5.2.1-alpha2):

#### Bug

* [#3469543](https://www.drupal.org/i/3469543) by pixelwhip: Cypress tests are failing in Tugboat
* [#3462489](https://www.drupal.org/i/3462489) by philip_stier, jldust, pixelwhip: Account for all breakpoints and order in spacing partial
* [#3473791](https://www.drupal.org/i/3473791) by pixelwhip, jldust, philip_stier: Simplify WYSIWIG stylesheet approach

#### Task

* [#3469567](https://www.drupal.org/i/3469567) by philip_stier, pixelwhip, jldust: Component Folder Structure
* [#3460616](https://www.drupal.org/i/3460616) by jldust, philip_stier: Seperate Menu Libraries

## 5.2.1-alpha2
This release includes a fix for the typography map not taking into account differences in breakpoints. This was resulting in missing custom properties or incorrect order of typography for different breakpoints when CSS is finally built for production. The Typography CSS Custom Property mixin was rewritten to include all breakpoints and build them in the correct order.

A feature update was made to the slideshow component to support more Splide API options and improved the default options to simplify developer experience.

### Changelog

**Issues**: 5 issues resolved.

Changes since [5.2.1-alpha1](https://www.drupal.org/project/prototype/releases/5.2.1-alpha1):

#### Bug

* [#3462492](https://www.drupal.org/i/3462492) by philip_stier, jldust, pixelwhip: Account for all breakpoints and order in typography partial

#### Feature

* [#3457470](https://www.drupal.org/i/3457470) by jldust, pixelwhip, philip_stier: Adjust the Slideshow api to handle more Splide options
* [#3471046](https://www.drupal.org/i/3471046) by jldust: Component: Add keyboard support as default for slideshow

#### Support

* [#3470712](https://www.drupal.org/i/3470712) by jldust: Update to Gulp v5

#### Task

* [#3466036](https://www.drupal.org/i/3466036) by jldust, michaelablackham, pixelwhip, philip_stier: Move the target for "skip to main link"

## 5.2.1-alpha1
This is a new minor release to account for the theme generator change with Drupal core 10.3 and also removes SDC as a requirement from the theme now that it is in Drupal core.

### Changelog

**Issues**: 3 issues resolved.

Changes since [5.2.0-alpha9](https://www.drupal.org/project/prototype/releases/5.2.0-alpha9):

#### Task

* [#3461850](https://www.drupal.org/i/3461850) by jldust, michaelablackham: Update Pager to remove error from Axe Dev Tools
* [#3443348](https://www.drupal.org/i/3443348) by pixelwhip, jldust, b-ry: Update to new starterkit.yml file
* [#3467253](https://www.drupal.org/i/3467253) by jldust: Remove SDC requirement for 10.3+

## 5.2.0-alpha9
This release includes a major overhaul of the menu components, removing the menu--navigation component and provided a more robust menu converted into vanilla JavaScript. The menu component supports setting custom mobile controls and breakpoints, and out of the box now supports arrow keys for menu navigation for better accessibility.

Minor fixes for the slideshow component have been added along with updated logos for the project.

A notable in this release is updating the node version from 18.15 to 20.11 along with supporting packages.

Changes since [5.2.0-alpha8](https://www.drupal.org/project/prototype/releases/5.2.0-alpha8):

#### Bug

* [#3457468](https://www.drupal.org/i/3457468) by pixelwhip: Slideshow doesn't support mediaQuery option
* [#3457466](https://www.drupal.org/i/3457466) by pixelwhip: Slideshow throws error when autoplay is set to false
* [#3460674](https://www.drupal.org/i/3460674) by jldust: Re-Add SVG logo

#### Feature

* [#3398391](https://www.drupal.org/i/3398391) by jldust: Convert Menu Component

#### Task

* [#3450739](https://www.drupal.org/i/3450739): Update theme to use node 20+
* [#3405850](https://www.drupal.org/i/3405850) by philip_stier: Fix empty logo.png file

## 5.2.0-alpha8
This release updates SASS build tasks to fail loudly to stop issues with CI tasks completing with errors. Updated the tab component as menu-tabs and new tab-content component. A structural change includes flattening the partials directory to simplify development process.

### Changelog

**Issues**: 2 issues resolved.

Changes since [5.2.0-alpha7](https://www.drupal.org/project/prototype/releases/5.2.0-alpha7):

#### Feature

* [#3374467](https://www.drupal.org/i/3374467) by philip_stier, jldust, pixelwhip, michaelablackham: Component: Tabs
* [#3443352](https://www.drupal.org/i/3443352) by jldust, philip_stier: Flatten partials directory

#### Misc

* Removing object from breadcrumb text type

## 5.2.0-alpha7
This is a bug fix release to address a missing field in node--teaser template, fix incorrectly escaped aria, and the breadcrumb component causing a WOD.

### Changelog

**Issues**: 3 issues resolved.

Changes since [5.2.0-alpha6](https://www.drupal.org/project/prototype/releases/5.2.0-alpha6):

#### Bug

* [#3443356](https://www.drupal.org/i/3443356) by jldust: Teaser missing required field
* [#3443351](https://www.drupal.org/i/3443351) by jldust: Incorrectly escaped aria for Accordion

#### Task

* [#3443357](https://www.drupal.org/i/3443357): Breadcrumb text needs to support objects and strings

## 5.2.0-alpha6
This release introduces several new features including Tugboat support for Drupal.org development, Cypress testing, a new slideshow component, and a new default spacing function for styling. Additionally this resolves some issues with the default teaser component and build steps failing. Gulp tasks have been converted to the new format away from the deprecated settings.

### Changelog

**Issues**: 11 issues resolved.

Changes since [5.2.0-alpha5](https://www.drupal.org/project/prototype/releases/5.2.0-alpha5):

#### Bug

* [#3440579](https://www.drupal.org/i/3440579): Build step fails due to missing includePaths option
* [#3440942](https://www.drupal.org/i/3440942): Cypress tests are out of date.
* [#3441682](https://www.drupal.org/i/3441682): Generator is out of date with recent changes.
* [#3437428](https://www.drupal.org/i/3437428) by pixelwhip, jnettik: Implement default model for spacing
* [#3443332](https://www.drupal.org/i/3443332) by jldust: Update styleguide demo for new components
* [#3437426](https://www.drupal.org/i/3437426) by jnettik: Table base styles

#### Feature

* [#3398393](https://www.drupal.org/i/3398393): Slideshow Component
* [#3427988](https://www.drupal.org/i/3427988): Add tugboat integration.

#### Task

* [#3428496](https://www.drupal.org/i/3428496) by jnettik, pixelwhip: Simplify Global's partial reference
* [#3426459](https://www.drupal.org/i/3426459) by jnettik: Clean up HTML template head
* [#3427970](https://www.drupal.org/i/3427970) by rishabjasrotia, pixelwhip, jnettik, jldust: Simplify Teaser component

## 5.2.0-alpha5
This release fixes a critical bug causing new themes to WOD on load due to an indentation issue.

There has been a need to test and update components so that they support themes using the enforce_schema functionality with their themes. Prior to this release there were several structural and schema issues that had not been addressed that when enforce_schema was enabled caused sites to display a WOD. This release includes an overhaul of component structures and schemas to addresses those errors.

### Changelog

**Issues**: 2 issues resolved.

Changes since [5.2.0-alpha4](https://www.drupal.org/project/prototype/releases/5.2.0-alpha4):

#### Bug

* [#3423986](https://www.drupal.org/i/3423986) by pixelwhip: Syntax error in prototype.libraries.yml

#### Task

* [#3416788](https://www.drupal.org/i/3416788) by jldust: SDC Components: Review all component schema structure

## 5.2.0-alpha4
This release introduces theme configuration in Prototype for the first time, including both install defaults for block region positioning and a new setting feature that allows users to enable/disable a back to top button through the UI. With the introduction of configuration the theme generator was updated to reflect the new folder structure so that future themes are provided this functionality by default.

### Changelog

**Issues**: 6 issues resolved.

Changes since [5.2.0-alpha3](https://www.drupal.org/project/prototype/releases/5.2.0-alpha3):

#### Bug

* [#3419303](https://www.drupal.org/i/3419303) by jnettik: Active trail broken in preprocess

#### Feature

* [#3421704](https://www.drupal.org/i/3421704) by jldust: Add optional install configs
* [#3312431](https://www.drupal.org/i/3312431) by jldust, pixelwhip: Design: Back-to-top Button
* [#3374468](https://www.drupal.org/i/3374468) by jldust: Component: Search Bar

#### Task

* [#3418792](https://www.drupal.org/i/3418792) by jldust: Update generator help commands
* [#3419890](https://www.drupal.org/i/3419890) by jldust: Replace list psuedo elements

## 5.2.0-alpha3
This release includes a major change for font sizes and line heights, it does include an API change and is notated at the bottom of this release. Once again a major shout out to pixelwhip for introducing a new scaling system and updated mixin.

### Changelog

**Issues**: 5 issues resolved.

Changes since [5.2.0-alpha2](https://www.drupal.org/project/prototype/releases/5.2.0-alpha2):

#### Bug

* [#3418233](https://www.drupal.org/i/3418233) by pixelwhip: CSS watch tasks writing sourcemaps twice
* [#3413130](https://www.drupal.org/i/3413130) by jldust, pdureau: SDC components: Fix JSON schema usage

#### Feature

* [#3418509](https://www.drupal.org/i/3418509) by pixelwhip: Add a vendor directory
* [#3417984](https://www.drupal.org/i/3417984) by pixelwhip, jldust: Set font-sizes and line-heights based on a typographic scale
* [#3380580](https://www.drupal.org/i/3380580) by jldust: Add abbreviation name for generator

## 5.2.0-alpha2
This release includes a major performance improvement for Prototype build tools that now listen to individual components and update changed files only, this drastically improves build time on large scale projects and a huge shoutout goes to pixelwhip for making these changes. Please note that this change can be implemented into older versions of the 5.x theme, see the update section at the bottom of this changelog.

### Changelog

**Issues**: 4 issues resolved.

Changes since [5.2.0-alpha1](https://www.drupal.org/project/prototype/releases/5.2.0-alpha1):

#### Bug

* [#3405342](https://www.drupal.org/i/3405342): Base CSS build command doesn't use PostCSS
* [#3413618](https://www.drupal.org/i/3413618) by pixelwhip: Library dependencies are incorrectly defined in *.component.yml files
* [#3415158](https://www.drupal.org/i/3415158) by pixelwhip: Reimplement incremental builds on watch command

#### Feature

* [#3414884](https://www.drupal.org/i/3414884) by pixelwhip: Add error handling for bp mixins

## 5.2.0-alpha1
This release includes a major fix that removes several unused props within components related to this Drupal Core issue that caused fresh installs of Prototype to only show a white screen. In addition, we included accessibility improvements such as adjusting the skip-link styles for better visibility and updating the way Prototype handled setting aria-labels within blocks.

New to this release is a figure component that leverages the media library and can be used within other components.

### Changelog

**Issues**: 7 issues resolved.

Changes since [5.1.2-alpha3](https://www.drupal.org/project/prototype/releases/5.1.2-alpha3):

#### Bug

* [#3400888](https://www.drupal.org/i/3400888) by jldust, jnettik: Skip to content link styles need changed
* [#3400717](https://www.drupal.org/i/3400717) by jnettik, jldust: Menu blocks set incorrect aria values for labelling
* [#3400890](https://www.drupal.org/i/3400890) by jldust, jnettik: Dropdown menus need to disable child links from tabbing
* [#3396443](https://www.drupal.org/i/3396443): Issue with the Mobile Nav open/close functionality
* [#3401399](https://www.drupal.org/i/3401399) by jldust: Drupal Message Icon WOD
* [#3381429](https://www.drupal.org/i/3381429) by asherry: Drupal\sdc\Exception\InvalidComponentException: [props.properties] Array value found, but an object is required

#### Feature

* [#3401379](https://www.drupal.org/i/3401379) by jldust: Component: Figure

## 5.1.2-alpha3
This release includes several typo and coding standard changes, along with a few dependency fixes for the menu components. We have also removed the more-link component.

### Changelog

**Issues**: 6 issues resolved.

Changes since [5.1.2-alpha2](https://www.drupal.org/project/prototype/releases/5.1.2-alpha2):

#### Bug

* [#3392019](https://www.drupal.org/i/3392019) by jnettik: Content Block bundle template suggestion doesn't work
* [#3395030](https://www.drupal.org/i/3395030) by tguerineau: Dropdown menu IDs shouldn't be based on content
* [#3398079](https://www.drupal.org/i/3398079) by jldust, viren18febS, jnettik: Component dependencies incorrectly defined

#### Task

* [#3392785](https://www.drupal.org/i/3392785) by jnettik, jldust: Typos in theme docs
* [#3392018](https://www.drupal.org/i/3392018) by jldust, bobi-mel, jnettik: Coding Standards
* [#3398447](https://www.drupal.org/i/3398447): Remove more-link component

## 5.1.2-alpha2
This release includes a minor fix for the footer and adds Breakpoint support.

### Changelog

**Issues**: 2 issues resolved.

Changes since [5.1.2-alpha1](https://www.drupal.org/project/prototype/releases/5.1.2-alpha1):

#### Bug

* [#3389659](https://www.drupal.org/i/3389659) by jnettik: Footer doesn't render blocks

#### Feature

* [#3388987](https://www.drupal.org/i/3388987) by philip_stier: Add Breakpoints YAML File

## 5.1.2-alpha1
This release includes major changes to the site header & menu components in which it replaces the site-header & site-footer with reusable menu components and removes several regions in favor of a single navigation region. This change removes the header, & progress-bar as they are no longer going to be maintained.

Built-in support for CKEditor5 has been added to styles along with updates to .browserlistrc, and a few other minor bug fixes.

### Changelog

**Issues**: 5 issues resolved.

Changes since [5.1.1-alpha2](https://www.drupal.org/project/prototype/releases/5.1.1-alpha2):

#### Bug

* [#3388642](https://www.drupal.org/i/3388642) by jldust: Menu Quick Fix

#### Feature

* [#3386820](https://www.drupal.org/i/3386820) by philip_stier, pixelwhip: Add CKEditor 5 specific stylesheet

#### Task

* [#3387386](https://www.drupal.org/i/3387386) by jldust, b-ry, Jaspreet-Kaur: Remove components
* [#3387385](https://www.drupal.org/i/3387385) by jldust, philip_stier: Restructure components
* [#3385993](https://www.drupal.org/i/3385993): Update .browserlistrc

## 5.1.1-alpha2
This release includes several bug fixes related to the generator and recent build tool changes. In addition these new SDC based components were added to the theme: Accordion, Button, Link, and Pager.

It is important to note that this release includes a major shift towards CSS based variables and an overhaul of their naming conventions within Prototype as well.

### Changelog

**Issues**: 12 issues resolved.

Changes since [5.1.1-alpha1](https://www.drupal.org/project/prototype/releases/5.1.1-alpha1):

#### Bug

* [#3378925](https://www.drupal.org/i/3378925) by jldust, philip_stier: Page title incorrect prop
* [#3382658](https://www.drupal.org/i/3382658) by jldust: Generator missing Components directory
* [#3380261](https://www.drupal.org/i/3380261) by philip_stier: Update Build Tools for Components Pathing
* [#3383203](https://www.drupal.org/i/3383203) by philip_stier: Missing site-header.js Source File
* [#3380579](https://www.drupal.org/i/3380579) by jldust, Shreya_th, pixelwhip: Move settings into theme section within the libraries.yml

#### Feature

* [#3375713](https://www.drupal.org/i/3375713) by jldust, philip_stier: Add footer logo support
* [#3375719](https://www.drupal.org/i/3375719) by jldust: Component: Pager
* [#3374425](https://www.drupal.org/i/3374425) by jldust: Upgrade Typography variables
* [#3374461](https://www.drupal.org/i/3374461) by jldust: Component: Buttons
* [#3374463](https://www.drupal.org/i/3374463): Component: Link
* [#3374143](https://www.drupal.org/i/3374143) by philip_stier: CSS Variable Conversion - 5.x
* [#3374426](https://www.drupal.org/i/3374426) by jldust: Component: Accordion

## 5.1.1-alpha1
This update brings Prototype inline with updated SDC syntax structure. With this release there was a new branding region that was added to account for updates made to support Drupal core branding blocks. Previously deprecated code from the 4.x version of Prototype has now been removed. A new default reset file has replaced the previous Normalize file, this should offer basic reset options while preserving browser defaults for accessibility.

### Changelog

**Issues**: 6 issues resolved.

Changes since [5.1.0-alpha3](https://www.drupal.org/project/prototype/releases/5.1.0-alpha3):

#### Bug

* [#3371460](https://www.drupal.org/i/3371460) by jldust: Update SDC Status within components

#### Feature

* [#3366850](https://www.drupal.org/i/3366850) by philip_stier: Replace Normalize with Reset on 5.x

#### Task

* [#3358011](https://www.drupal.org/i/3358011) by jldust, elber: Removed 4.x deprecated code in .theme file
* [#3366844](https://www.drupal.org/i/3366844) by jldust: Support Drupal branding block
* [#3371459](https://www.drupal.org/i/3371459) by jldust: Update page.html.twig template & regions
* [#3371196](https://www.drupal.org/i/3371196) by jldust, droath: Fix SDC component syntax

## 5.1.0-alpha3
This update brings Prototype inline with utilizing the SDC module supported in Drupal core 10.1. There have been structural changes between the contrib module and that which now lives in core, to account for these we have updated those files to account for these changes. The composer file for Prototype no longer requires the contrib module to resolve potential module conflicts.

### Changelog

**Issues**: 3 issues resolved.

Changes since [5.1.0-alpha2](https://www.drupal.org/project/prototype/releases/5.1.0-alpha2):

#### Bug

* [#3370243](https://www.drupal.org/i/3370243) by jldust, droath: Remove SDC module from the composer.json as it's apart of Drupal 10
* [#3370328](https://www.drupal.org/i/3370328) by jldust, droath: Update Component Metadata For SDC 10.1

#### Task

* [#3370331](https://www.drupal.org/i/3370331) by jldust: Update 5.1.x Info File

## 5.1.0-alpha2
Bug fix: Schema errors with incorrect props

### Changelog

**Issues**: 1 issues resolved.

Changes since [5.1.0-alpha1](https://www.drupal.org/project/prototype/releases/5.1.0-alpha1):

#### Bug

* [#3361345](https://www.drupal.org/i/3361345) by jldust: Schema errors on SDC branches

## 5.1.0-alpha1
Initial alpha release for 5.0.x branch, includes shifting structural components away from the Components! module towards using Single Directory Components (SDC). This release supports D9 with the SDC module and not the core module as it is only included in Drupal 10.

### Changelog

**Issues**: 0 issues resolved.

Changes since [5.0.0-alpha2](https://www.drupal.org/project/prototype/releases/5.0.0-alpha2):

#### Misc

* Updating dependencies for D10 & SDC


## 5.0.0-alpha2

### Changelog

**Issues**: 1 issues resolved.

Changes since [5.0.0-alpha1](https://www.drupal.org/project/prototype/releases/5.0.0-alpha1):

#### Bug

* 3361345 Updating Schema files to resolve WOD issues

## 5.0.0-alpha1
5.x is a structural shift towards Single Directory Components

### Changelog

**Issues**: 1 issues resolved.

Changes since [4.0.0-beta1](https://www.drupal.org/project/prototype/releases/4.0.0-beta1):

#### Feature

* [#3353795](https://www.drupal.org/i/3353795) by jldust, b-ry: Introduce Single Directory Components

#### Misc

* Updating dependencies for D9 & SDC
* Adjusted theme description

## 4.x - [Unreleased]
The 4.x release marks a move from Prototype as a starter-kit to Prototype as an actual base theme. It also shifts away from a heavy use of custom Sass mixins and functions, instead embracing future enhancements to the CSS spec enabled by the [PostCSS Env](https://github.com/csstools/postcss-preset-env) plugin. *It is not recommended to update from Prototype 8.2.x to 4.x.* Without creating a brand new sub theme. There are too many breaking changes. In reality, if you are already using Prototype 2.x, there is very little code in Prototype that would not already be overriden by your existing sub-theme.

It is the intention of the project maintainers to release incremental enhancements which, due to the nature of themes, have a high risk of breaking changes. We will do our best to document those here.

### Added

- Drupal 9 support.
- This `CHANGELOG.md`!
- Build tool configuration additions.
    - [Browserlist](https://github.com/browserslist/browserslist) support to control the list of browsers targeted by [Babel](https://babeljs.io/), [PostCSS Env](https://github.com/csstools/postcss-preset-env) and [Autoprefixer](https://github.com/postcss/autoprefixer).
    - Additional [Babel](https://babeljs.io/) overrides can be configured with `.babelrc` if Browserlist is insufficient.
    - Support for setting [Browsersync](https://browsersync.io/) configuration in an `.env` file to make the build tools more portable across environments.
    - A minimal set of [Tailwind CSS](https://tailwindcss.com/) utility classes. These can be modified via `tailwind.config.js`.
    - [Webpack](https://webpack.js.org/) support for JS bundling. This can be controlled via `webpack.config.js`
- Accessible JS libraries added.
    - (WIP) Added `toggle.js` library.
    - (WIP) Added `tabbed.js` library.
    - (WIP) Added `a11y-dialog.js` library.
- Layout utility classes have been added based on patterns described in [Every Layout](https://every-layout.dev/) by Heydon Pickering and Andy Bell.
    - `.l-stack` for [controlling vertical spacing](https://every-layout.dev/layouts/stack/).
    - `.l-cluster` for [consistent spacing](https://every-layout.dev/layouts/cluster/) between horizontal flowing block elements.
    - `.l-grid` for [multi-column grids](https://every-layout.dev/layouts/grid/).
- (WIP) Cypress tests have been added.
- Styled: Status Messages

### Changed

- Most Sass variables have been replaced with [CSS Custom properties](https://developer.mozilla.org/en-US/docs/Web/CSS/Using_CSS_custom_properties). These Properties follow a naming convention based on the ["Naming Tokens in Design Systems"](https://medium.com/eightshapes-llc/naming-tokens-in-design-systems-9e86c7444676) article by Nathan Curtis.
- (WIP) CSS classes have been namespaced – loosely following the conventions outlined in the ["More Transparent UI Code with Namespaces"](https://csswizardry.com/2015/03/more-transparent-ui-code-with-namespaces/) article by Harry Roberts.
    - `.c-` for component classes.
    - `.l-` for layout classes.
    - `.t-` for themes and color schemes.
    - `.u-` for utility classes.
    - `.is-` and `.has` for state classes.
    - `.js-` for attaching JavaScript behaviors.
- `.l-constrained` has been rewritten to better adapt to dynamic changes to it's container.
- (WIP) Form css has been rewritten from the ground up.
- (WIP) Base text styles have been rewritten.
- The front-end build tools have been completely updated to provide more control via tool specific config files such as `.browserlistrc` and `.postcssrc.js` and less reliance on editing gulp files directly or editing `config.js`, although it still may be necessary in some cases.
    - [Browserify](https://browserify.org/) has been replaced by [Webpack](https://webpack.js.org/) as the main JavaScript bundler.
    - [Node-sass](https://github.com/sass/node-sass) has been replaced with [Dart-sass](https://sass-lang.com/dart-sass).
    - `sass-lint` CSS linting has been replaced with `.stylelintrc.json` to conform with Drupal standards. However we do prefer alphabetized CSS properties over Drupal's groupings.
- The structure of `prototype.libraries.yml` has been refactored to allow sub-themes more granular control when overriding and extending libraries. This includes more appropriate use of [CSS library namespaces](https://www.drupal.org/docs/develop/standards/css/css-file-organization-for-drupal-9) for more control on source order.
- `.header` and `.footer` have been renamed to `.c-site-header` and `.c-site-footer` to better distinguish them from other header and footer elements.

- Gulp tasks have been moved into a folder named `gulpfile.js`.

### Removed

- The STARTER_KIT folder and bash script have been removed as this prevented Prototype from being installed as a stand-alone theme without a sub-theme. New sub-themes can be generated using the [Prototype Sub-theme](https://github.com/AtenDesignGroup/generator-prototype-subtheme) Yeoman generator.
- [Breakpoint-sass](http://breakpoint-sass.com/) along with the `bp()` mixin have been removed as it is no longer maintained. This functionality is replaced by added support for [Custom Media Queries](https://github.com/postcss/postcss-custom-media) and [Media Minmax](https://github.com/postcss/postcss-media-minmax) via PostCSS Env
- All font related Sass mixins and their related Sass maps and variables have been removed in favor of CSS custom properties.
- `global.js` was removed. This was an empty JS file that encouraged bad practices of loading JS globally and was often removed from subthemes anyway.
- The build process no longer attempts code splitting JS modules into common chunks. Instead developers are encouraged to load necessary external JS libraries as UMD modules and declare dependencies using Drupal's libraries API.  If your scripts are complicated enough to warrant code-splitting, they are most likely providing functionality that is more complicated than what the theme layer should provide. These scripts are likely more suited to a custom module.

## [8.2.x] - 2017-09-20

### Added

- Added STARTER_KIT folder and related bash script.

## [8.1.x] - 2017-04-18

- Initial Drupal 8 release.

## [7.3.x] - 2017-04-18

### Changed

- Replaced [Compass](http://compass-style.org/) with [Libsass](https://sass-lang.com/libsass)

## [7.1.x] - 2017-04-18

- Initial Drupal 7 release.

[unreleased]: https://git.drupalcode.org/project/prototype/-/compare/8.x-2.x...4.x?from_project_id=57591
[8.2.x]: https://git.drupalcode.org/project/prototype/-/compare/8.x-1.x...8.x-2.x?from_project_id=57591
[8.1.x]: https://git.drupalcode.org/project/prototype/-/compare/7.x-3.x...8.x-1.x?from_project_id=57591
[7.3.x]: https://git.drupalcode.org/project/prototype/-/compare/7.x-1.x...7.x-3.x?from_project_id=57591
[7.1.x]: https://git.drupalcode.org/project/prototype/-/tree/7.x-1.x
